package cn.gygxzc.tina.cloud.bus.messager.sender.impl;

import cn.gygxzc.tina.cloud.bus.constant.QueueName;
import cn.gygxzc.tina.cloud.bus.messager.bean.MessageBean;
import cn.gygxzc.tina.cloud.bus.messager.sender.IMessagerSender;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * Created by niantuo on 2018/9/29.
 * 发送给消息中心的发送者
 */
@Component
public class MessagerSender implements IMessagerSender {

    private final AmqpTemplate amqpTemplate;

    @Autowired
    public MessagerSender(AmqpTemplate amqpTemplate) {
        this.amqpTemplate = amqpTemplate;
    }

    /**
     * 发送消息给消息中心
     *
     * @param message 消息内容
     */
    @Override
    public void send(MessageBean message) {
        amqpTemplate.convertAndSend(QueueName.Messager, message);
    }
}
