package cn.gygxzc.envir.test.service.impl;

import cn.gygxzc.envir.test.dao.ITestLogDao;
import cn.gygxzc.envir.test.model.TestLog;
import cn.gygxzc.envir.test.service.ITestLogService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by niantuo on 2018/9/30.
 */
@Service
public class TestLogService implements ITestLogService {
    private final static Logger logger = LoggerFactory.getLogger(TestLogService.class);

    private final ITestLogDao testLogDao;

    @Autowired
    public TestLogService(ITestLogDao testLogDao) {
        this.testLogDao = testLogDao;
    }


    @Override
    public TestLog addLog(TestLog log) {
        int result = testLogDao.insert(log);
        logger.info("add log  result:{},entity:{}", result, log);
        return log;
    }

    @Override
    public void update(TestLog log) {
        int result = testLogDao.updateById(log);
        logger.info("update result:{},entity:{}", result, log);
    }

    @Override
    public void physicalDeleteById(long id) {
        int result = testLogDao.physicalDeleteById(id);
        logger.info("physicalDeleteById result:{}", result);

    }

    @Override
    public void deleteById(long id) {
        int result = testLogDao.deleteById(id);
        logger.info("deleteById  result:{}", result);
    }
}
