package cn.gygxzc.envir.utils

import java.util.*

/**
 * 字节 16进制字串转换工具类
 * @author NorthLan
 * @date 2018/4/23
 * @url https://noahlan.com
 */
object Byte2Hex {

    /**
     *
     * 字节转换为 16 进制字符串
     *
     * @param b
     * 字节
     * @return
     */
    fun byte2Hex(b: Byte): String {
        var hex = Integer.toHexString(b.toInt())
        if (hex.length > 2) {
            hex = hex.substring(hex.length - 2)
        }
        while (hex.length < 2) {
            hex = "0$hex"
        }
        return hex
    }


    /**
     *
     * 字节数组转换为 16 进制字符串
     *
     * @param bytes
     * 字节数组
     * @return
     */
    fun byte2Hex(bytes: ByteArray): String {
        val formatter = Formatter()
        for (b in bytes) {
            formatter.format("%02x", b)
        }
        val hash = formatter.toString()
        formatter.close()
        return hash
    }
}