package com.gxzc.zen.logging.model

import java.io.Serializable
import java.util.*

/**
 * 请求日志 model
 * @author NorthLan
 * @date 2018/8/23
 * @url https://noahlan.com
 */
open class LogRequest : Serializable {
    companion object {
        private const val serialVersionUID = 10000000000000002L
    }

    /**
     * 平台ID
     */
    var platformId: Int? = null

    /**
     * 请求URI
     */
    var requestUri: String? = null

    /**
     * 请求方法
     */
    var requestMethod: String? = null

    /**
     * 请求携带参数
     */
    var requestParam: String? = null

    /**
     * 请求内容体
     */
    var requestBody: String? = null

    /**
     * 返回内容
     */
    var responseBody: String? = null

    /**
     * targetMethod 请求方法
     */
    var method: String? = null

    /**
     * 操作人account
     */
    var operatorAccount: String? = null

    /**
     * 操作人name
     */
    var operatorName: String? = null

    /**
     * 操作开始时间
     */
    var operatorStartTime: Date = Date()

    /**
     * 操作结束时间
     */
    var operatorEndTime: Date = Date()

    /**
     * 客户端host
     */
    var remoteHost: String? = null

    /**
     * 异常信息
     */
    var exMsg: String? = null

    /**
     * 备注
     */
    var remark: String? = null
}