package cn.gygxzc.tina.cache.caffeine

import org.springframework.boot.context.properties.ConfigurationProperties
import java.util.*

/**
 * Created by niantuo on 2018/9/29.
 * caffeine 内存缓存配置
 */
@ConfigurationProperties(prefix = "cache.caffeine")
class CaffeineProperties {

    var enable = true
    var cacheSpec = HashMap<String, CacheSpec>()

    /**
     * 缓存配置
     */
    class CacheSpec {
        var initialCapacity: Int = 0
        var maximumSize: Long = 0
        var maximumWeight: Long = 0
        var expireAfterAccess: Long = 0
        var expireAfterWrite: Long = 0
        var refreshAfterWrite: Long = 0
        var isWeakKeys: Boolean = false
        var isWeakValues: Boolean = false
        var isSoftValues: Boolean = false
        var isRecordStats: Boolean = false
    }
}
