package cn.gygxzc.tina.orm

import cn.gygxzc.tina.orm.handler.CustomMetaObjectHandler
import cn.gygxzc.tina.orm.injector.LogicMoreSqlInjector
import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler
import com.baomidou.mybatisplus.core.injector.ISqlInjector
import com.baomidou.mybatisplus.extension.injector.LogicSqlInjector
import com.baomidou.mybatisplus.extension.plugins.PaginationInterceptor
import com.baomidou.mybatisplus.extension.plugins.PerformanceInterceptor
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.context.annotation.Profile
import org.springframework.transaction.annotation.EnableTransactionManagement

/**
 *
 * @author NorthLan at 2018/1/30
 * mybatis plus 配置
 */
@Configuration
@EnableTransactionManagement
class MybatisPlusConfig {


    /**
     * 并不会自动注入
     */
    @Bean
    fun physicalSqlInjector(): ISqlInjector {
        return LogicMoreSqlInjector()
    }


    /**
     * 性能分析插件
     */
    @Bean
    @Profile("dev") // 开发环境开启
    fun performanceInterceptor(): PerformanceInterceptor {
        return PerformanceInterceptor().also { it.isFormat = true }
    }

    /**
     * 分页插件
     */
    @Bean
    fun paginationInterceptor(): PaginationInterceptor {
        return PaginationInterceptor()
    }

    @Bean
    fun metaObjectHandler(): MetaObjectHandler {
        return CustomMetaObjectHandler()
    }

}