package com.gxzc.zen.common.base

import cn.gygxzc.tina.orm.base.BaseModel
import com.baomidou.mybatisplus.annotation.*
import com.fasterxml.jackson.annotation.JsonInclude
import io.swagger.annotations.ApiModelProperty
import java.io.Serializable
import java.util.*

/**
 * 通用实体 包含通用字段
 * @author NorthLan at 2017/12/8
 */
@Deprecated("移到另一个包下，cn.gygxzc.tina.orm.base")
@JsonInclude(JsonInclude.Include.ALWAYS) // jackson 所有
open class BaseModel : Serializable {
    companion object {
        private const val serialVersionUID = 1000000000000000001L
    }

    // 主键
    @TableId(type = IdType.ID_WORKER)
    var id: Long? = null

    // 创建时间
    @TableField(fill = FieldFill.INSERT)
    @ApiModelProperty(hidden = true)
    var createTime: Date? = null

    // 创建人id
    @TableField(fill = FieldFill.INSERT)
    var createBy: String? = null

    // 更新时间
    @TableField(fill = FieldFill.UPDATE)
    var updateTime: Date? = null

    // 更新人id
    @TableField(fill = FieldFill.UPDATE)
    var updateBy: String? = null

    // 备注
    var remark: String? = null

//    @TableField(exist = false)
//    private var createdByName: String? = null

//    @TableField(exist = false)
//    private var updatedByName: String? = null

    @TableLogic(value = "1", delval = "0")
    @TableField("'enable'")
    var enable: Boolean? = null

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other !is BaseModel) return false

        if (id != other.id) return false
        if (createTime != other.createTime) return false
        if (createBy != other.createBy) return false
        if (updateTime != other.updateTime) return false
        if (updateBy != other.updateBy) return false
        if (remark != other.remark) return false
        if (enable != other.enable) return false

        return true
    }

    override fun hashCode(): Int {
        var result = id?.hashCode() ?: 0
        result = 31 * result + (createTime?.hashCode() ?: 0)
        result = 31 * result + (createBy?.hashCode() ?: 0)
        result = 31 * result + (updateTime?.hashCode() ?: 0)
        result = 31 * result + (updateBy?.hashCode() ?: 0)
        result = 31 * result + (remark?.hashCode() ?: 0)
        result = 31 * result + (enable?.hashCode() ?: 0)
        return result
    }


}
