package cn.gygxzc.envir.api.sys.controller

import cn.gygxzc.envir.sys.dto.LoginDto
import cn.gygxzc.envir.sys.service.ILoginService
import io.swagger.annotations.Api
import io.swagger.annotations.ApiOperation
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

/**
 * @program: Zen-Framework
 *
 * @description: ${description}
 *
 * @author: tuonina
 *
 * @create: 2018-09-20 22:45
 **/
@RestController
@RequestMapping("/v1/login")
@Api(tags = ["登陆API"])
class LoginController {

    @Autowired
    private lateinit var loginService: ILoginService

    /**
     * 登陆成功之后，签发jwt凭证
     */
    @PostMapping("/app")
    @ApiOperation("用户登陆，返回jwt token")
    fun loginForJwt(@RequestBody dto: LoginDto): Any {
        return loginService.login(dto)
    }

}