package cn.gygxzc.envir.api.test.controller

import cn.gygxzc.envir.test.model.TestLog
import cn.gygxzc.envir.test.service.ITestLogService
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*

/**
 * Created by niantuo on 2018/9/30.
 * 测试用的，正式打包将其注释掉
 */
@RestController
@RequestMapping("/test/log")
class TestLogController {

    companion object {
        private val logger = LoggerFactory.getLogger(TestLogController::class.java)
    }

    @Autowired
    private lateinit var testLogService: ITestLogService

    /**
     * 添加数据
     */
    @PostMapping
    fun add(@RequestBody log: TestLog) {
        val result = testLogService.addLog(log)
        logger.info("add result:{}", result)
    }

    /**
     * 修改数据
     */
    @PutMapping
    fun update(@RequestBody log: TestLog) {
        val result = testLogService.update(log)
        logger.info("add result:{}", result)
    }

    @DeleteMapping("/{id}")
    fun deleteById(@PathVariable("id") id: Long) {
        testLogService.deleteById(id)
    }

    @DeleteMapping("/physical/{id}")
    fun physicalDeleteById(@PathVariable("id") id: Long) {
        testLogService.physicalDeleteById(id)
    }


}