package cn.gygxzc.envir.config

import io.swagger.annotations.ApiOperation
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import springfox.documentation.builders.ApiInfoBuilder
import springfox.documentation.builders.RequestHandlerSelectors
import springfox.documentation.service.ApiInfo
import springfox.documentation.service.Contact
import springfox.documentation.spi.DocumentationType
import springfox.documentation.spring.web.plugins.Docket
import springfox.documentation.swagger2.annotations.EnableSwagger2

/**
 * @program: Zen-Framework
 *
 * @description: ${description}
 *
 * @author: tuonina
 *
 * @create: 2018-09-20 22:39
 **/
@Configuration
@EnableSwagger2
@ConditionalOnProperty(prefix = "swagger", name = ["open"], havingValue = "true")
class SwaggerConfiguration {

    @Bean
    fun createApi(): Docket {
        return Docket(DocumentationType.SWAGGER_2)
                .groupName("v1")
                .apiInfo(apiInfo())
                .select()
//                .apis(RequestHandlerSelectors.withClassAnnotation(RestController::class.java))
                .apis(RequestHandlerSelectors.withMethodAnnotation(ApiOperation::class.java))
                .build()
//                .securitySchemes()
    }

    private fun apiInfo(): ApiInfo {
        return ApiInfoBuilder()
                .title("Envir Doc")
                .description("Zen Api Document")
                .termsOfServiceUrl("")
                .contact(Contact("NorthLan", "https://noahlan.com", "lan6995@gmail.com"))
                .version("2.0")
                .license("!!!private!!!")
                .build()
    }
}